<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>OpenThread: src/core/thread/mle_router.hpp Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="../../Open-Thread-Logo-200x42.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">
   &#160;<span id="projectnumber">gddd0704</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="../../index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="../../modules.html"><span>Modules</span></a></li>
      <li><a href="../../namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="../../annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="../../files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="../../search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="../../search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="../../files.html"><span>File&#160;List</span></a></li>
      <li><a href="../../globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('d6/d6f/mle__router_8hpp_source.html','../../');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">mle_router.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="../../d6/d6f/mle__router_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> *  Copyright (c) 2016, The OpenThread Authors.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *  All rights reserved.</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *  Redistribution and use in source and binary forms, with or without</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> *  modification, are permitted provided that the following conditions are met:</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *  1. Redistributions of source code must retain the above copyright</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     notice, this list of conditions and the following disclaimer.</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *  2. Redistributions in binary form must reproduce the above copyright</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> *     notice, this list of conditions and the following disclaimer in the</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> *     documentation and/or other materials provided with the distribution.</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> *  3. Neither the name of the copyright holder nor the</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *     names of its contributors may be used to endorse or promote products</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *     derived from this software without specific prior written permission.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS &quot;AS IS&quot;</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> *  POSSIBILITY OF SUCH DAMAGE.</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#ifndef MLE_ROUTER_HPP_</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#define MLE_ROUTER_HPP_</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#include &lt;string.h&gt;</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../d1/d8d/coap__header_8hpp.html">coap/coap_header.hpp</a>&gt;</span></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../dd/d28/coap__server_8hpp.html">coap/coap_server.hpp</a>&gt;</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../df/d05/timer_8hpp.html">common/timer.hpp</a>&gt;</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../d0/d11/trickle__timer_8hpp.html">common/trickle_timer.hpp</a>&gt;</span></div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../d1/d97/mac__frame_8hpp.html">mac/mac_frame.hpp</a>&gt;</span></div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../d0/dba/icmp6_8hpp.html">net/icmp6.hpp</a>&gt;</span></div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../d0/db7/udp6_8hpp.html">net/udp6.hpp</a>&gt;</span></div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../d0/d78/mle_8hpp.html">thread/mle.hpp</a>&gt;</span></div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../d1/df7/mle__tlvs_8hpp.html">thread/mle_tlvs.hpp</a>&gt;</span></div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../d8/d26/thread__tlvs_8hpp.html">thread/thread_tlvs.hpp</a>&gt;</span></div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../df/d4b/topology_8hpp.html">thread/topology.hpp</a>&gt;</span></div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="keyword">namespace </span><a class="code" href="../../d9/d00/namespaceThread.html">Thread</a> {</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="keyword">namespace </span>Mle {</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="keyword">class </span>MeshForwarder;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="keyword">class </span>NetworkDataLeader;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;<a class="code" href="../../d7/da1/group__toolchain.html#gaba6ad63129c3a790957a9b149a65891b">OT_TOOL_PACKED_BEGIN</a></div><div class="line"><a name="l00071"></a><span class="lineno"><a class="line" href="../../d2/df0/classThread_1_1Mle_1_1DelayedResponseHeader.html">   71</a></span>&#160;<span class="keyword">class </span><a class="code" href="../../d2/df0/classThread_1_1Mle_1_1DelayedResponseHeader.html">DelayedResponseHeader</a></div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;{</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00078"></a><span class="lineno"><a class="line" href="../../db/dec/group__core-mle-router.html#ga12833392b18ea07b87b0aa7103140baa">   78</a></span>&#160;    <a class="code" href="../../db/dec/group__core-mle-router.html#ga12833392b18ea07b87b0aa7103140baa">DelayedResponseHeader</a>(<span class="keywordtype">void</span>) { memset(<span class="keyword">this</span>, 0, <span class="keyword">sizeof</span>(*<span class="keyword">this</span>)); };</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div><div class="line"><a name="l00087"></a><span class="lineno"><a class="line" href="../../db/dec/group__core-mle-router.html#ga825a23482e5abe06ed2c0efb9343d614">   87</a></span>&#160;    <a class="code" href="../../db/dec/group__core-mle-router.html#ga825a23482e5abe06ed2c0efb9343d614">DelayedResponseHeader</a>(uint32_t aSendTime, <span class="keyword">const</span> <a class="code" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Ip6::Address</a> &amp;aDestination) {</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        mSendTime = aSendTime;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        mDestination = aDestination;</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    };</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;</div><div class="line"><a name="l00101"></a><span class="lineno"><a class="line" href="../../db/dec/group__core-mle-router.html#ga6e4dd015cd242d97b89d2523f5132cf8">  101</a></span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> <a class="code" href="../../db/dec/group__core-mle-router.html#ga6e4dd015cd242d97b89d2523f5132cf8">AppendTo</a>(<a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage) {</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        <span class="keywordflow">return</span> aMessage.<a class="code" href="../../dc/d3c/classThread_1_1Message.html#a3c3d1c48e940f2553586d16e1618277d">Append</a>(<span class="keyword">this</span>, <span class="keyword">sizeof</span>(*<span class="keyword">this</span>));</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    };</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;</div><div class="line"><a name="l00113"></a><span class="lineno"><a class="line" href="../../db/dec/group__core-mle-router.html#gac459664defd97a4462d24b88153e188b">  113</a></span>&#160;    uint16_t <a class="code" href="../../db/dec/group__core-mle-router.html#gac459664defd97a4462d24b88153e188b">ReadFrom</a>(<a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage) {</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;        <span class="keywordflow">return</span> aMessage.<a class="code" href="../../dc/d3c/classThread_1_1Message.html#a76033bbc15170d72452186058defafa2">Read</a>(aMessage.<a class="code" href="../../dc/d3c/classThread_1_1Message.html#a2cf440376e834030c38bb2ced4ca49e9">GetLength</a>() - <span class="keyword">sizeof</span>(*this), <span class="keyword">sizeof</span>(*this), <span class="keyword">this</span>);</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    };</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div><div class="line"><a name="l00125"></a><span class="lineno"><a class="line" href="../../db/dec/group__core-mle-router.html#gaadf8242dcc10ab86e29321ac2ffa771c">  125</a></span>&#160;    <span class="keyword">static</span> <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> <a class="code" href="../../db/dec/group__core-mle-router.html#gaadf8242dcc10ab86e29321ac2ffa771c">RemoveFrom</a>(<a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage) {</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;        <span class="keywordflow">return</span> aMessage.<a class="code" href="../../dc/d3c/classThread_1_1Message.html#acecf07ee065974c8b211c151ea5d6e14">SetLength</a>(aMessage.<a class="code" href="../../dc/d3c/classThread_1_1Message.html#a2cf440376e834030c38bb2ced4ca49e9">GetLength</a>() - <span class="keyword">sizeof</span>(<a class="code" href="../../db/dec/group__core-mle-router.html#ga12833392b18ea07b87b0aa7103140baa">DelayedResponseHeader</a>));</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;    };</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;</div><div class="line"><a name="l00135"></a><span class="lineno"><a class="line" href="../../db/dec/group__core-mle-router.html#ga24a903e04afeadc6df85db9fac018e2f">  135</a></span>&#160;    uint32_t <a class="code" href="../../db/dec/group__core-mle-router.html#ga24a903e04afeadc6df85db9fac018e2f">GetSendTime</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSendTime; };</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;</div><div class="line"><a name="l00143"></a><span class="lineno"><a class="line" href="../../db/dec/group__core-mle-router.html#ga0c53ff489783f2b58e8f070a3ff54e3c">  143</a></span>&#160;    <span class="keyword">const</span> <a class="code" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Ip6::Address</a> &amp;<a class="code" href="../../db/dec/group__core-mle-router.html#ga0c53ff489783f2b58e8f070a3ff54e3c">GetDestination</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mDestination; };</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;</div><div class="line"><a name="l00153"></a><span class="lineno"><a class="line" href="../../db/dec/group__core-mle-router.html#gaa2e15142a8cca7f278fd4d887aca6e3f">  153</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="../../db/dec/group__core-mle-router.html#gaa2e15142a8cca7f278fd4d887aca6e3f">IsEarlier</a>(uint32_t aTime) { <span class="keywordflow">return</span> (static_cast&lt;int32_t&gt;(aTime - mSendTime) &gt; 0); };</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;</div><div class="line"><a name="l00163"></a><span class="lineno"><a class="line" href="../../db/dec/group__core-mle-router.html#gadb5de3038cf6d4ca911f3ba9160c3bdf">  163</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="../../db/dec/group__core-mle-router.html#gadb5de3038cf6d4ca911f3ba9160c3bdf">IsLater</a>(uint32_t aTime) { <span class="keywordflow">return</span> (static_cast&lt;int32_t&gt;(aTime - mSendTime) &lt; 0); };</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;    <a class="code" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Ip6::Address</a> mDestination;  </div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;    uint32_t mSendTime;         </div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;} <a class="code" href="../../d7/da1/group__toolchain.html#gacf07d7a4a2ea6d0cc3426234565fcb7b">OT_TOOL_PACKED_END</a>;</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;</div><div class="line"><a name="l00174"></a><span class="lineno"><a class="line" href="../../df/da5/classThread_1_1Mle_1_1MleRouter.html">  174</a></span>&#160;<span class="keyword">class </span><a class="code" href="../../df/da5/classThread_1_1Mle_1_1MleRouter.html">MleRouter</a>: <span class="keyword">public</span> <a class="code" href="../../dd/ddf/classThread_1_1Mle_1_1Mle.html">Mle</a></div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;{</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;    <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="../../dd/ddf/classThread_1_1Mle_1_1Mle.html">Mle</a>;</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;    <span class="keyword">explicit</span> <a class="code" href="../../df/da5/classThread_1_1Mle_1_1MleRouter.html">MleRouter</a>(<a class="code" href="../../d3/d8e/classThread_1_1ThreadNetif.html">ThreadNetif</a> &amp;aThreadNetif);</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;    <span class="keywordtype">bool</span> IsRouterRoleEnabled(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;    <span class="keywordtype">void</span> SetRouterRoleEnabled(<span class="keywordtype">bool</span> aEnabled);</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;    <span class="keywordtype">bool</span> IsSingleton(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> BecomeRouter(<a class="code" href="../../d4/df4/classThread_1_1ThreadStatusTlv.html#a0a1376dc8bb01111ac1a21170188fdf8">ThreadStatusTlv::Status</a> aStatus);</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> BecomeLeader(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;    uint8_t GetActiveRouterCount(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;    uint32_t GetLeaderAge(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;    uint8_t GetLeaderWeight(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;    <span class="keywordtype">void</span> SetLeaderWeight(uint8_t aWeight);</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;    uint32_t GetLeaderPartitionId(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;    <span class="keywordtype">void</span> SetLeaderPartitionId(uint32_t aPartitionId);</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SetPreferredRouterId(uint8_t aRouterId);</div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;    uint16_t GetNextHop(uint16_t aDestination) <span class="keyword">const</span>;</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;    uint8_t GetNetworkIdTimeout(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;</div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;    <span class="keywordtype">void</span> SetNetworkIdTimeout(uint8_t aTimeout);</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;</div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;    uint8_t GetRouteCost(uint16_t aRloc16) <span class="keyword">const</span>;</div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;    uint8_t GetRouterIdSequence(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;    uint8_t GetRouterUpgradeThreshold(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;</div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;    <span class="keywordtype">void</span> SetRouterUpgradeThreshold(uint8_t aThreshold);</div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;</div><div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;    uint8_t GetRouterDowngradeThreshold(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div><div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;</div><div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;    <span class="keywordtype">void</span> SetRouterDowngradeThreshold(uint8_t aThreshold);</div><div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;</div><div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> ReleaseRouterId(uint8_t aRouterId);</div><div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;</div><div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> RemoveNeighbor(<span class="keyword">const</span> <a class="code" href="../../dd/dcd/structThread_1_1Mac_1_1Address.html">Mac::Address</a> &amp;aAddress);</div><div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;</div><div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> RemoveNeighbor(<a class="code" href="../../da/dd9/classThread_1_1Neighbor.html">Neighbor</a> &amp;aNeighbor);</div><div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;</div><div class="line"><a name="l00416"></a><span class="lineno">  416</span>&#160;    <a class="code" href="../../d3/de7/classThread_1_1Child.html">Child</a> *GetChild(uint16_t aAddress);</div><div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;</div><div class="line"><a name="l00426"></a><span class="lineno">  426</span>&#160;    <a class="code" href="../../d3/de7/classThread_1_1Child.html">Child</a> *GetChild(<span class="keyword">const</span> <a class="code" href="../../d9/d3c/classThread_1_1Mac_1_1ExtAddress.html">Mac::ExtAddress</a> &amp;aAddress);</div><div class="line"><a name="l00427"></a><span class="lineno">  427</span>&#160;</div><div class="line"><a name="l00436"></a><span class="lineno">  436</span>&#160;    <a class="code" href="../../d3/de7/classThread_1_1Child.html">Child</a> *GetChild(<span class="keyword">const</span> <a class="code" href="../../dd/dcd/structThread_1_1Mac_1_1Address.html">Mac::Address</a> &amp;aAddress);</div><div class="line"><a name="l00437"></a><span class="lineno">  437</span>&#160;</div><div class="line"><a name="l00446"></a><span class="lineno">  446</span>&#160;    uint8_t GetChildIndex(<span class="keyword">const</span> <a class="code" href="../../d3/de7/classThread_1_1Child.html">Child</a> &amp;aChild);</div><div class="line"><a name="l00447"></a><span class="lineno">  447</span>&#160;</div><div class="line"><a name="l00456"></a><span class="lineno">  456</span>&#160;    <a class="code" href="../../d3/de7/classThread_1_1Child.html">Child</a> *GetChildren(uint8_t *aNumChildren);</div><div class="line"><a name="l00457"></a><span class="lineno">  457</span>&#160;</div><div class="line"><a name="l00468"></a><span class="lineno">  468</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SetMaxAllowedChildren(uint8_t aMaxChildren);</div><div class="line"><a name="l00469"></a><span class="lineno">  469</span>&#160;</div><div class="line"><a name="l00478"></a><span class="lineno">  478</span>&#160;    <a class="code" href="../../da/dd9/classThread_1_1Neighbor.html">Neighbor</a> *GetNeighbor(uint16_t aAddress);</div><div class="line"><a name="l00479"></a><span class="lineno">  479</span>&#160;</div><div class="line"><a name="l00488"></a><span class="lineno">  488</span>&#160;    <a class="code" href="../../da/dd9/classThread_1_1Neighbor.html">Neighbor</a> *GetNeighbor(<span class="keyword">const</span> <a class="code" href="../../d9/d3c/classThread_1_1Mac_1_1ExtAddress.html">Mac::ExtAddress</a> &amp;aAddress);</div><div class="line"><a name="l00489"></a><span class="lineno">  489</span>&#160;</div><div class="line"><a name="l00498"></a><span class="lineno">  498</span>&#160;    <a class="code" href="../../da/dd9/classThread_1_1Neighbor.html">Neighbor</a> *GetNeighbor(<span class="keyword">const</span> <a class="code" href="../../dd/dcd/structThread_1_1Mac_1_1Address.html">Mac::Address</a> &amp;aAddress);</div><div class="line"><a name="l00499"></a><span class="lineno">  499</span>&#160;</div><div class="line"><a name="l00508"></a><span class="lineno">  508</span>&#160;    <a class="code" href="../../da/dd9/classThread_1_1Neighbor.html">Neighbor</a> *GetNeighbor(<span class="keyword">const</span> <a class="code" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Ip6::Address</a> &amp;aAddress);</div><div class="line"><a name="l00509"></a><span class="lineno">  509</span>&#160;</div><div class="line"><a name="l00517"></a><span class="lineno">  517</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> GetChildInfoById(uint16_t aChildId, <a class="code" href="../../d3/d06/structotChildInfo.html">otChildInfo</a> &amp;aChildInfo);</div><div class="line"><a name="l00518"></a><span class="lineno">  518</span>&#160;</div><div class="line"><a name="l00526"></a><span class="lineno">  526</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> GetChildInfoByIndex(uint8_t aChildIndex, <a class="code" href="../../d3/d06/structotChildInfo.html">otChildInfo</a> &amp;aChildInfo);</div><div class="line"><a name="l00527"></a><span class="lineno">  527</span>&#160;</div><div class="line"><a name="l00540"></a><span class="lineno">  540</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> GetNextNeighborInfo(<a class="code" href="../../d8/dd2/group__diags.html#ga9af04696139e51b2ab276b117319216a">otNeighborInfoIterator</a> &amp;aIterator, <a class="code" href="../../d9/df7/structotNeighborInfo.html">otNeighborInfo</a> &amp;aNeighInfo);</div><div class="line"><a name="l00541"></a><span class="lineno">  541</span>&#160;</div><div class="line"><a name="l00550"></a><span class="lineno">  550</span>&#160;    <a class="code" href="../../db/d81/classThread_1_1Router.html">Router</a> *GetRouters(uint8_t *aNumRouters);</div><div class="line"><a name="l00551"></a><span class="lineno">  551</span>&#160;</div><div class="line"><a name="l00559"></a><span class="lineno">  559</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> GetRouterInfo(uint16_t aRouterId, <a class="code" href="../../d9/d96/structotRouterInfo.html">otRouterInfo</a> &amp;aRouterInfo);</div><div class="line"><a name="l00560"></a><span class="lineno">  560</span>&#160;</div><div class="line"><a name="l00567"></a><span class="lineno">  567</span>&#160;    <span class="keywordtype">void</span> HandleMacDataRequest(<span class="keyword">const</span> <a class="code" href="../../d3/de7/classThread_1_1Child.html">Child</a> &amp;aChild);</div><div class="line"><a name="l00568"></a><span class="lineno">  568</span>&#160;</div><div class="line"><a name="l00582"></a><span class="lineno">  582</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">int</span> ComparePartitions(<span class="keywordtype">bool</span> aSingletonA, <span class="keyword">const</span> <a class="code" href="../../d5/d64/classThread_1_1Mle_1_1LeaderDataTlv.html">LeaderDataTlv</a> &amp;aLeaderDataA,</div><div class="line"><a name="l00583"></a><span class="lineno">  583</span>&#160;                                 <span class="keywordtype">bool</span> aSingletonB, <span class="keyword">const</span> <a class="code" href="../../d5/d64/classThread_1_1Mle_1_1LeaderDataTlv.html">LeaderDataTlv</a> &amp;aleaderDataB);</div><div class="line"><a name="l00584"></a><span class="lineno">  584</span>&#160;</div><div class="line"><a name="l00596"></a><span class="lineno">  596</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> CheckReachability(uint16_t aMeshSource, uint16_t aMeshDest, <a class="code" href="../../d8/d6e/classThread_1_1Ip6_1_1Header.html">Ip6::Header</a> &amp;aIp6Header);</div><div class="line"><a name="l00597"></a><span class="lineno">  597</span>&#160;</div><div class="line"><a name="l00607"></a><span class="lineno">  607</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SendLinkReject(<span class="keyword">const</span> <a class="code" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Ip6::Address</a> &amp;aDestination);</div><div class="line"><a name="l00608"></a><span class="lineno">  608</span>&#160;</div><div class="line"><a name="l00618"></a><span class="lineno"><a class="line" href="../../db/dec/group__core-mle-router.html#ga68eea6791f7f1ab21eda738487066b14">  618</a></span>&#160;    <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="../../db/dec/group__core-mle-router.html#ga68eea6791f7f1ab21eda738487066b14">IsRouterIdValid</a>(uint8_t aRouterId) { <span class="keywordflow">return</span> aRouterId &lt;= <a class="code" href="../../d2/dd4/namespaceThread_1_1Mle.html#a1f47251fa36b57c412cc091444be9489a1fe8b460a7e0b570b11e234a74d02d2e">kMaxRouterId</a>; }</div><div class="line"><a name="l00619"></a><span class="lineno">  619</span>&#160;</div><div class="line"><a name="l00626"></a><span class="lineno">  626</span>&#160;    <span class="keywordtype">void</span> FillConnectivityTlv(<a class="code" href="../../d2/df0/classThread_1_1Mle_1_1ConnectivityTlv.html">ConnectivityTlv</a> &amp;aTlv);</div><div class="line"><a name="l00627"></a><span class="lineno">  627</span>&#160;</div><div class="line"><a name="l00634"></a><span class="lineno">  634</span>&#160;    <span class="keywordtype">void</span> FillRouteTlv(<a class="code" href="../../d6/d9e/classThread_1_1Mle_1_1RouteTlv.html">RouteTlv</a> &amp;aTlv);</div><div class="line"><a name="l00635"></a><span class="lineno">  635</span>&#160;</div><div class="line"><a name="l00636"></a><span class="lineno">  636</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00637"></a><span class="lineno">  637</span>&#160;    <span class="keyword">enum</span></div><div class="line"><a name="l00638"></a><span class="lineno">  638</span>&#160;    {</div><div class="line"><a name="l00639"></a><span class="lineno">  639</span>&#160;        kStateUpdatePeriod = 1000u,  </div><div class="line"><a name="l00640"></a><span class="lineno">  640</span>&#160;    };</div><div class="line"><a name="l00641"></a><span class="lineno">  641</span>&#160;</div><div class="line"><a name="l00642"></a><span class="lineno">  642</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> AppendConnectivity(<a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage);</div><div class="line"><a name="l00643"></a><span class="lineno">  643</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> AppendChildAddresses(<a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <a class="code" href="../../d3/de7/classThread_1_1Child.html">Child</a> &amp;aChild);</div><div class="line"><a name="l00644"></a><span class="lineno">  644</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> AppendRoute(<a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage);</div><div class="line"><a name="l00645"></a><span class="lineno">  645</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> AppendActiveDataset(<a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage);</div><div class="line"><a name="l00646"></a><span class="lineno">  646</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> AppendPendingDataset(<a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage);</div><div class="line"><a name="l00647"></a><span class="lineno">  647</span>&#160;    uint8_t GetLinkCost(uint8_t aRouterId);</div><div class="line"><a name="l00648"></a><span class="lineno">  648</span>&#160;    <span class="keywordtype">void</span> GetChildInfo(<a class="code" href="../../d3/de7/classThread_1_1Child.html">Child</a> &amp;aChild, <a class="code" href="../../d3/d06/structotChildInfo.html">otChildInfo</a> &amp;aChildInfo);</div><div class="line"><a name="l00649"></a><span class="lineno">  649</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> HandleDetachStart(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00650"></a><span class="lineno">  650</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> HandleChildStart(<a class="code" href="../../db/d57/group__config-test.html#gae4ed9d6e7bf2a1d196d9e36f3769e7b8">otMleAttachFilter</a> aFilter);</div><div class="line"><a name="l00651"></a><span class="lineno">  651</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> HandleLinkRequest(<span class="keyword">const</span> <a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aMessageInfo);</div><div class="line"><a name="l00652"></a><span class="lineno">  652</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> HandleLinkAccept(<span class="keyword">const</span> <a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aMessageInfo, uint32_t aKeySequence);</div><div class="line"><a name="l00653"></a><span class="lineno">  653</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> HandleLinkAccept(<span class="keyword">const</span> <a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aMessageInfo, uint32_t aKeySequence,</div><div class="line"><a name="l00654"></a><span class="lineno">  654</span>&#160;                                 <span class="keywordtype">bool</span> request);</div><div class="line"><a name="l00655"></a><span class="lineno">  655</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> HandleLinkAcceptAndRequest(<span class="keyword">const</span> <a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aMessageInfo,</div><div class="line"><a name="l00656"></a><span class="lineno">  656</span>&#160;                                           uint32_t aKeySequence);</div><div class="line"><a name="l00657"></a><span class="lineno">  657</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> HandleLinkReject(<span class="keyword">const</span> <a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aMessageInfo);</div><div class="line"><a name="l00658"></a><span class="lineno">  658</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> HandleAdvertisement(<span class="keyword">const</span> <a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aMessageInfo);</div><div class="line"><a name="l00659"></a><span class="lineno">  659</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> HandleParentRequest(<span class="keyword">const</span> <a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aMessageInfo);</div><div class="line"><a name="l00660"></a><span class="lineno">  660</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> HandleChildIdRequest(<span class="keyword">const</span> <a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aMessageInfo,</div><div class="line"><a name="l00661"></a><span class="lineno">  661</span>&#160;                                     uint32_t aKeySequence);</div><div class="line"><a name="l00662"></a><span class="lineno">  662</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> HandleChildUpdateRequest(<span class="keyword">const</span> <a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aMessageInfo);</div><div class="line"><a name="l00663"></a><span class="lineno">  663</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> HandleDataRequest(<span class="keyword">const</span> <a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aMessageInfo);</div><div class="line"><a name="l00664"></a><span class="lineno">  664</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> HandleNetworkDataUpdateRouter(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00665"></a><span class="lineno">  665</span>&#160;</div><div class="line"><a name="l00666"></a><span class="lineno">  666</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> ProcessRouteTlv(<span class="keyword">const</span> <a class="code" href="../../d6/d9e/classThread_1_1Mle_1_1RouteTlv.html">RouteTlv</a> &amp;aRoute);</div><div class="line"><a name="l00667"></a><span class="lineno">  667</span>&#160;    <span class="keywordtype">void</span> ResetAdvertiseInterval(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00668"></a><span class="lineno">  668</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SendAddressSolicit(<a class="code" href="../../d4/df4/classThread_1_1ThreadStatusTlv.html#a0a1376dc8bb01111ac1a21170188fdf8">ThreadStatusTlv::Status</a> aStatus);</div><div class="line"><a name="l00669"></a><span class="lineno">  669</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SendAddressRelease(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00670"></a><span class="lineno">  670</span>&#160;    <span class="keywordtype">void</span> SendAddressSolicitResponse(<span class="keyword">const</span> <a class="code" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html">Coap::Header</a> &amp;aRequest, uint8_t aRouterId,</div><div class="line"><a name="l00671"></a><span class="lineno">  671</span>&#160;                                    <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aMessageInfo);</div><div class="line"><a name="l00672"></a><span class="lineno">  672</span>&#160;    <span class="keywordtype">void</span> SendAddressReleaseResponse(<span class="keyword">const</span> <a class="code" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html">Coap::Header</a> &amp;aRequestHeader, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aMessageInfo);</div><div class="line"><a name="l00673"></a><span class="lineno">  673</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SendAdvertisement(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00674"></a><span class="lineno">  674</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SendLinkRequest(<a class="code" href="../../da/dd9/classThread_1_1Neighbor.html">Neighbor</a> *aNeighbor);</div><div class="line"><a name="l00675"></a><span class="lineno">  675</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SendLinkAccept(<span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aMessageInfo, <a class="code" href="../../da/dd9/classThread_1_1Neighbor.html">Neighbor</a> *aNeighbor,</div><div class="line"><a name="l00676"></a><span class="lineno">  676</span>&#160;                               <span class="keyword">const</span> <a class="code" href="../../d0/d08/classThread_1_1Mle_1_1TlvRequestTlv.html">TlvRequestTlv</a> &amp;aTlvRequest, <span class="keyword">const</span> <a class="code" href="../../da/d3f/classThread_1_1Mle_1_1ChallengeTlv.html">ChallengeTlv</a> &amp;aChallenge);</div><div class="line"><a name="l00677"></a><span class="lineno">  677</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SendParentResponse(<a class="code" href="../../d3/de7/classThread_1_1Child.html">Child</a> *aChild, <span class="keyword">const</span> <a class="code" href="../../da/d3f/classThread_1_1Mle_1_1ChallengeTlv.html">ChallengeTlv</a> &amp;aChallenge, <span class="keywordtype">bool</span> aRoutersOnlyRequest);</div><div class="line"><a name="l00678"></a><span class="lineno">  678</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SendChildIdResponse(<a class="code" href="../../d3/de7/classThread_1_1Child.html">Child</a> *aChild);</div><div class="line"><a name="l00679"></a><span class="lineno">  679</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SendChildUpdateResponse(<a class="code" href="../../d3/de7/classThread_1_1Child.html">Child</a> *aChild, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aMessageInfo,</div><div class="line"><a name="l00680"></a><span class="lineno">  680</span>&#160;                                        <span class="keyword">const</span> uint8_t *aTlvs, uint8_t aTlvsLength,  <span class="keyword">const</span> <a class="code" href="../../da/d3f/classThread_1_1Mle_1_1ChallengeTlv.html">ChallengeTlv</a> *challenge);</div><div class="line"><a name="l00681"></a><span class="lineno">  681</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SendDataResponse(<span class="keyword">const</span> <a class="code" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Ip6::Address</a> &amp;aDestination, <span class="keyword">const</span> uint8_t *aTlvs, uint8_t aTlvsLength);</div><div class="line"><a name="l00682"></a><span class="lineno">  682</span>&#160;</div><div class="line"><a name="l00683"></a><span class="lineno">  683</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SetStateRouter(uint16_t aRloc16);</div><div class="line"><a name="l00684"></a><span class="lineno">  684</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SetStateLeader(uint16_t aRloc16);</div><div class="line"><a name="l00685"></a><span class="lineno">  685</span>&#160;    <span class="keywordtype">void</span> StopLeader(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00686"></a><span class="lineno">  686</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> UpdateChildAddresses(<span class="keyword">const</span> <a class="code" href="../../df/dd8/classThread_1_1Mle_1_1AddressRegistrationTlv.html">AddressRegistrationTlv</a> &amp;aTlv, <a class="code" href="../../d3/de7/classThread_1_1Child.html">Child</a> &amp;aChild);</div><div class="line"><a name="l00687"></a><span class="lineno">  687</span>&#160;    <span class="keywordtype">void</span> UpdateRoutes(<span class="keyword">const</span> <a class="code" href="../../d6/d9e/classThread_1_1Mle_1_1RouteTlv.html">RouteTlv</a> &amp;aTlv, uint8_t aRouterId);</div><div class="line"><a name="l00688"></a><span class="lineno">  688</span>&#160;</div><div class="line"><a name="l00689"></a><span class="lineno">  689</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> HandleUdpReceive(<span class="keywordtype">void</span> *aContext, <a class="code" href="../../d4/d7c/group__messages.html#ga461fb1347aeb99b1d4aab520915e121e">otMessage</a> aMessage, <span class="keyword">const</span> <a class="code" href="../../dd/d76/structotMessageInfo.html">otMessageInfo</a> *aMessageInfo);</div><div class="line"><a name="l00690"></a><span class="lineno">  690</span>&#160;    <span class="keywordtype">void</span> HandleUdpReceive(<a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aMessageInfo);</div><div class="line"><a name="l00691"></a><span class="lineno">  691</span>&#160;    <span class="keywordtype">void</span> HandleAddressSolicitResponse(<a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage);</div><div class="line"><a name="l00692"></a><span class="lineno">  692</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> HandleAddressRelease(<span class="keywordtype">void</span> *aContext, <a class="code" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html">Coap::Header</a> &amp;aHeader, <a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage,</div><div class="line"><a name="l00693"></a><span class="lineno">  693</span>&#160;                                     <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aMessageInfo);</div><div class="line"><a name="l00694"></a><span class="lineno">  694</span>&#160;    <span class="keywordtype">void</span> HandleAddressRelease(<a class="code" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html">Coap::Header</a> &amp;aHeader, <a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aMessageInfo);</div><div class="line"><a name="l00695"></a><span class="lineno">  695</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> HandleAddressSolicit(<span class="keywordtype">void</span> *aContext, <a class="code" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html">Coap::Header</a> &amp;aHeader, <a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage,</div><div class="line"><a name="l00696"></a><span class="lineno">  696</span>&#160;                                     <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aMessageInfo);</div><div class="line"><a name="l00697"></a><span class="lineno">  697</span>&#160;    <span class="keywordtype">void</span> HandleAddressSolicit(<a class="code" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html">Coap::Header</a> &amp;aHeader, <a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Ip6::MessageInfo</a> &amp;aMessageInfo);</div><div class="line"><a name="l00698"></a><span class="lineno">  698</span>&#160;</div><div class="line"><a name="l00699"></a><span class="lineno">  699</span>&#160;    <span class="keyword">static</span> uint8_t LqiToCost(uint8_t aLqi);</div><div class="line"><a name="l00700"></a><span class="lineno">  700</span>&#160;</div><div class="line"><a name="l00701"></a><span class="lineno">  701</span>&#160;    <a class="code" href="../../d3/de7/classThread_1_1Child.html">Child</a> *NewChild(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00702"></a><span class="lineno">  702</span>&#160;    <a class="code" href="../../d3/de7/classThread_1_1Child.html">Child</a> *FindChild(uint16_t aChildId);</div><div class="line"><a name="l00703"></a><span class="lineno">  703</span>&#160;    <a class="code" href="../../d3/de7/classThread_1_1Child.html">Child</a> *FindChild(<span class="keyword">const</span> <a class="code" href="../../d9/d3c/classThread_1_1Mac_1_1ExtAddress.html">Mac::ExtAddress</a> &amp;aMacAddr);</div><div class="line"><a name="l00704"></a><span class="lineno">  704</span>&#160;</div><div class="line"><a name="l00705"></a><span class="lineno">  705</span>&#160;    <span class="keywordtype">bool</span> HasMinDowngradeNeighborRouters(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00706"></a><span class="lineno">  706</span>&#160;    <span class="keywordtype">bool</span> HasOneNeighborwithComparableConnectivity(<span class="keyword">const</span> <a class="code" href="../../d6/d9e/classThread_1_1Mle_1_1RouteTlv.html">RouteTlv</a> &amp;aRoute, uint8_t aRouterId);</div><div class="line"><a name="l00707"></a><span class="lineno">  707</span>&#160;    <span class="keywordtype">bool</span> HasSmallNumberOfChildren(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00708"></a><span class="lineno">  708</span>&#160;    uint8_t GetMinDowngradeNeighborRouters(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00709"></a><span class="lineno">  709</span>&#160;</div><div class="line"><a name="l00710"></a><span class="lineno">  710</span>&#160;    uint8_t AllocateRouterId(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00711"></a><span class="lineno">  711</span>&#160;    uint8_t AllocateRouterId(uint8_t aRouterId);</div><div class="line"><a name="l00712"></a><span class="lineno">  712</span>&#160;    <span class="keywordtype">bool</span> InRouterIdMask(uint8_t aRouterId);</div><div class="line"><a name="l00713"></a><span class="lineno">  713</span>&#160;</div><div class="line"><a name="l00714"></a><span class="lineno">  714</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">bool</span> HandleAdvertiseTimer(<span class="keywordtype">void</span> *aContext);</div><div class="line"><a name="l00715"></a><span class="lineno">  715</span>&#160;    <span class="keywordtype">bool</span> HandleAdvertiseTimer(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00716"></a><span class="lineno">  716</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> HandleStateUpdateTimer(<span class="keywordtype">void</span> *aContext);</div><div class="line"><a name="l00717"></a><span class="lineno">  717</span>&#160;    <span class="keywordtype">void</span> HandleStateUpdateTimer(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00718"></a><span class="lineno">  718</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> HandleDelayedResponseTimer(<span class="keywordtype">void</span> *aContext);</div><div class="line"><a name="l00719"></a><span class="lineno">  719</span>&#160;    <span class="keywordtype">void</span> HandleDelayedResponseTimer(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00720"></a><span class="lineno">  720</span>&#160;</div><div class="line"><a name="l00721"></a><span class="lineno">  721</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> AddDelayedResponse(<a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Ip6::Address</a> &amp;aDestination, uint16_t aDelay);</div><div class="line"><a name="l00722"></a><span class="lineno">  722</span>&#160;</div><div class="line"><a name="l00723"></a><span class="lineno">  723</span>&#160;    <a class="code" href="../../da/d1a/classThread_1_1MessageQueue.html">MessageQueue</a> mDelayedResponses;</div><div class="line"><a name="l00724"></a><span class="lineno">  724</span>&#160;</div><div class="line"><a name="l00725"></a><span class="lineno">  725</span>&#160;    <a class="code" href="../../dd/d68/classThread_1_1TrickleTimer.html">TrickleTimer</a> mAdvertiseTimer;</div><div class="line"><a name="l00726"></a><span class="lineno">  726</span>&#160;    <a class="code" href="../../d1/d40/classThread_1_1Timer.html">Timer</a> mStateUpdateTimer;</div><div class="line"><a name="l00727"></a><span class="lineno">  727</span>&#160;    <a class="code" href="../../d1/d40/classThread_1_1Timer.html">Timer</a> mDelayedResponseTimer;</div><div class="line"><a name="l00728"></a><span class="lineno">  728</span>&#160;</div><div class="line"><a name="l00729"></a><span class="lineno">  729</span>&#160;    <a class="code" href="../../dc/d75/classThread_1_1Ip6_1_1UdpSocket.html">Ip6::UdpSocket</a> mSocket;</div><div class="line"><a name="l00730"></a><span class="lineno">  730</span>&#160;    <a class="code" href="../../d0/d63/classThread_1_1Coap_1_1Resource.html">Coap::Resource</a> mAddressSolicit;</div><div class="line"><a name="l00731"></a><span class="lineno">  731</span>&#160;    <a class="code" href="../../d0/d63/classThread_1_1Coap_1_1Resource.html">Coap::Resource</a> mAddressRelease;</div><div class="line"><a name="l00732"></a><span class="lineno">  732</span>&#160;</div><div class="line"><a name="l00733"></a><span class="lineno">  733</span>&#160;    uint8_t mRouterIdSequence;</div><div class="line"><a name="l00734"></a><span class="lineno">  734</span>&#160;    uint32_t mRouterIdSequenceLastUpdated;</div><div class="line"><a name="l00735"></a><span class="lineno">  735</span>&#160;    <a class="code" href="../../db/d81/classThread_1_1Router.html">Router</a> mRouters[<a class="code" href="../../d2/dd4/namespaceThread_1_1Mle.html#a1f47251fa36b57c412cc091444be9489a1fe8b460a7e0b570b11e234a74d02d2e">kMaxRouterId</a> + 1];</div><div class="line"><a name="l00736"></a><span class="lineno">  736</span>&#160;    uint8_t mMaxChildrenAllowed;</div><div class="line"><a name="l00737"></a><span class="lineno">  737</span>&#160;    <a class="code" href="../../d3/de7/classThread_1_1Child.html">Child</a> mChildren[kMaxChildren];</div><div class="line"><a name="l00738"></a><span class="lineno">  738</span>&#160;</div><div class="line"><a name="l00739"></a><span class="lineno">  739</span>&#160;    uint8_t mChallengeTimeout;</div><div class="line"><a name="l00740"></a><span class="lineno">  740</span>&#160;    uint8_t mChallenge[8];</div><div class="line"><a name="l00741"></a><span class="lineno">  741</span>&#160;    uint16_t mNextChildId;</div><div class="line"><a name="l00742"></a><span class="lineno">  742</span>&#160;    uint8_t mNetworkIdTimeout;</div><div class="line"><a name="l00743"></a><span class="lineno">  743</span>&#160;    uint8_t mRouterUpgradeThreshold;</div><div class="line"><a name="l00744"></a><span class="lineno">  744</span>&#160;    uint8_t mRouterDowngradeThreshold;</div><div class="line"><a name="l00745"></a><span class="lineno">  745</span>&#160;    uint8_t mLeaderWeight;</div><div class="line"><a name="l00746"></a><span class="lineno">  746</span>&#160;    uint32_t mFixedLeaderPartitionId;  </div><div class="line"><a name="l00747"></a><span class="lineno">  747</span>&#160;    <span class="keywordtype">bool</span> mRouterRoleEnabled;</div><div class="line"><a name="l00748"></a><span class="lineno">  748</span>&#160;</div><div class="line"><a name="l00749"></a><span class="lineno">  749</span>&#160;    uint8_t mRouterId;</div><div class="line"><a name="l00750"></a><span class="lineno">  750</span>&#160;    uint8_t mPreviousRouterId;</div><div class="line"><a name="l00751"></a><span class="lineno">  751</span>&#160;</div><div class="line"><a name="l00752"></a><span class="lineno">  752</span>&#160;    <a class="code" href="../../de/d76/classThread_1_1Coap_1_1Server.html">Coap::Server</a> &amp;mCoapServer;</div><div class="line"><a name="l00753"></a><span class="lineno">  753</span>&#160;    uint8_t mCoapToken[2];</div><div class="line"><a name="l00754"></a><span class="lineno">  754</span>&#160;    uint16_t mCoapMessageId;</div><div class="line"><a name="l00755"></a><span class="lineno">  755</span>&#160;};</div><div class="line"><a name="l00756"></a><span class="lineno">  756</span>&#160;</div><div class="line"><a name="l00757"></a><span class="lineno">  757</span>&#160;}  <span class="comment">// namespace Mle</span></div><div class="line"><a name="l00758"></a><span class="lineno">  758</span>&#160;</div><div class="line"><a name="l00763"></a><span class="lineno">  763</span>&#160;}  <span class="comment">// namespace Thread</span></div><div class="line"><a name="l00764"></a><span class="lineno">  764</span>&#160;</div><div class="line"><a name="l00765"></a><span class="lineno">  765</span>&#160;<span class="preprocessor">#endif  // MLE_ROUTER_HPP_</span></div><div class="ttc" id="classThread_1_1Neighbor_html"><div class="ttname"><a href="../../da/dd9/classThread_1_1Neighbor.html">Thread::Neighbor</a></div><div class="ttdoc">This class represents a Thread neighbor. </div><div class="ttdef"><b>Definition:</b> topology.hpp:49</div></div>
<div class="ttc" id="classThread_1_1Mle_1_1RouteTlv_html"><div class="ttname"><a href="../../d6/d9e/classThread_1_1Mle_1_1RouteTlv.html">Thread::Mle::RouteTlv</a></div><div class="ttdoc">This class implements Source Address TLV generation and parsing. </div><div class="ttdef"><b>Definition:</b> mle_tlvs.hpp:450</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1MessageInfo_html"><div class="ttname"><a href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">Thread::Ip6::MessageInfo</a></div><div class="ttdoc">This class implements message information for an IPv6 message. </div><div class="ttdef"><b>Definition:</b> socket.hpp:54</div></div>
<div class="ttc" id="mle_8hpp_html"><div class="ttname"><a href="../../d0/d78/mle_8hpp.html">mle.hpp</a></div><div class="ttdoc">This file includes definitions for MLE functionality required by the Thread Child, Router, and Leader roles. </div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1Header_html"><div class="ttname"><a href="../../d8/d6e/classThread_1_1Ip6_1_1Header.html">Thread::Ip6::Header</a></div><div class="ttdoc">This class implements IPv6 header generation and parsing. </div><div class="ttdef"><b>Definition:</b> ip6_headers.hpp:132</div></div>
<div class="ttc" id="group__core-mle-router_html_ga0c53ff489783f2b58e8f070a3ff54e3c"><div class="ttname"><a href="../../db/dec/group__core-mle-router.html#ga0c53ff489783f2b58e8f070a3ff54e3c">Thread::Mle::DelayedResponseHeader::GetDestination</a></div><div class="ttdeci">const Ip6::Address &amp; GetDestination(void) const </div><div class="ttdoc">This method returns a destination of the delayed message. </div><div class="ttdef"><b>Definition:</b> mle_router.hpp:143</div></div>
<div class="ttc" id="classThread_1_1Mle_1_1TlvRequestTlv_html"><div class="ttname"><a href="../../d0/d08/classThread_1_1Mle_1_1TlvRequestTlv.html">Thread::Mle::TlvRequestTlv</a></div><div class="ttdoc">This class implements Source Address TLV generation and parsing. </div><div class="ttdef"><b>Definition:</b> mle_tlvs.hpp:859</div></div>
<div class="ttc" id="classThread_1_1Message_html"><div class="ttname"><a href="../../dc/d3c/classThread_1_1Message.html">Thread::Message</a></div><div class="ttdoc">This class represents a message. </div><div class="ttdef"><b>Definition:</b> message.hpp:213</div></div>
<div class="ttc" id="classThread_1_1Child_html"><div class="ttname"><a href="../../d3/de7/classThread_1_1Child.html">Thread::Child</a></div><div class="ttdoc">This class represents a Thread Child. </div><div class="ttdef"><b>Definition:</b> topology.hpp:98</div></div>
<div class="ttc" id="coap__header_8hpp_html"><div class="ttname"><a href="../../d1/d8d/coap__header_8hpp.html">coap_header.hpp</a></div><div class="ttdoc">This file includes definitions for generating and processing CoAP headers. </div></div>
<div class="ttc" id="namespaceThread_1_1Mle_html_a1f47251fa36b57c412cc091444be9489a1fe8b460a7e0b570b11e234a74d02d2e"><div class="ttname"><a href="../../d2/dd4/namespaceThread_1_1Mle.html#a1f47251fa36b57c412cc091444be9489a1fe8b460a7e0b570b11e234a74d02d2e">Thread::Mle::kMaxRouterId</a></div><div class="ttdoc">MAX_ROUTER_ID. </div><div class="ttdef"><b>Definition:</b> mle_constants.hpp:88</div></div>
<div class="ttc" id="classThread_1_1Mle_1_1ChallengeTlv_html"><div class="ttname"><a href="../../da/d3f/classThread_1_1Mle_1_1ChallengeTlv.html">Thread::Mle::ChallengeTlv</a></div><div class="ttdoc">This class implements Source Address TLV generation and parsing. </div><div class="ttdef"><b>Definition:</b> mle_tlvs.hpp:311</div></div>
<div class="ttc" id="group__diags_html_ga9af04696139e51b2ab276b117319216a"><div class="ttname"><a href="../../d8/dd2/group__diags.html#ga9af04696139e51b2ab276b117319216a">otNeighborInfoIterator</a></div><div class="ttdeci">int16_t otNeighborInfoIterator</div><div class="ttdoc">Used to iterate through neighbor table. </div><div class="ttdef"><b>Definition:</b> openthread-types.h:727</div></div>
<div class="ttc" id="classThread_1_1ThreadNetif_html"><div class="ttname"><a href="../../d3/d8e/classThread_1_1ThreadNetif.html">Thread::ThreadNetif</a></div><div class="ttdef"><b>Definition:</b> thread_netif.hpp:85</div></div>
<div class="ttc" id="structotRouterInfo_html"><div class="ttname"><a href="../../d9/d96/structotRouterInfo.html">otRouterInfo</a></div><div class="ttdoc">This structure holds diagnostic information for a Thread Router. </div><div class="ttdef"><b>Definition:</b> openthread-types.h:753</div></div>
<div class="ttc" id="group__core-mle-router_html_ga24a903e04afeadc6df85db9fac018e2f"><div class="ttname"><a href="../../db/dec/group__core-mle-router.html#ga24a903e04afeadc6df85db9fac018e2f">Thread::Mle::DelayedResponseHeader::GetSendTime</a></div><div class="ttdeci">uint32_t GetSendTime(void) const </div><div class="ttdoc">This method returns a time when the message shall be sent. </div><div class="ttdef"><b>Definition:</b> mle_router.hpp:135</div></div>
<div class="ttc" id="openthread-types_8h_html_ab701d053a9c34ab7f11e43e0dc09ac9f"><div class="ttname"><a href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a></div><div class="ttdeci">ThreadError</div><div class="ttdoc">This enumeration represents error codes used throughout OpenThread. </div><div class="ttdef"><b>Definition:</b> openthread-types.h:75</div></div>
<div class="ttc" id="topology_8hpp_html"><div class="ttname"><a href="../../df/d4b/topology_8hpp.html">topology.hpp</a></div><div class="ttdoc">This file includes definitions for maintaining Thread network topologies. </div></div>
<div class="ttc" id="classThread_1_1TrickleTimer_html"><div class="ttname"><a href="../../dd/d68/classThread_1_1TrickleTimer.html">Thread::TrickleTimer</a></div><div class="ttdoc">This class implements a trickle timer. </div><div class="ttdef"><b>Definition:</b> trickle_timer.hpp:55</div></div>
<div class="ttc" id="thread__tlvs_8hpp_html"><div class="ttname"><a href="../../d8/d26/thread__tlvs_8hpp.html">thread_tlvs.hpp</a></div><div class="ttdoc">This file includes definitions and methods for generating and processing Thread Network Layer TLVs...</div></div>
<div class="ttc" id="classThread_1_1Message_html_acecf07ee065974c8b211c151ea5d6e14"><div class="ttname"><a href="../../dc/d3c/classThread_1_1Message.html#acecf07ee065974c8b211c151ea5d6e14">Thread::Message::SetLength</a></div><div class="ttdeci">ThreadError SetLength(uint16_t aLength)</div><div class="ttdoc">This method sets the number of bytes in the message. </div><div class="ttdef"><b>Definition:</b> message.cpp:174</div></div>
<div class="ttc" id="group__core-mle-router_html_ga12833392b18ea07b87b0aa7103140baa"><div class="ttname"><a href="../../db/dec/group__core-mle-router.html#ga12833392b18ea07b87b0aa7103140baa">Thread::Mle::DelayedResponseHeader::DelayedResponseHeader</a></div><div class="ttdeci">DelayedResponseHeader(void)</div><div class="ttdoc">Default constructor for the object. </div><div class="ttdef"><b>Definition:</b> mle_router.hpp:78</div></div>
<div class="ttc" id="group__core-mle-router_html_ga825a23482e5abe06ed2c0efb9343d614"><div class="ttname"><a href="../../db/dec/group__core-mle-router.html#ga825a23482e5abe06ed2c0efb9343d614">Thread::Mle::DelayedResponseHeader::DelayedResponseHeader</a></div><div class="ttdeci">DelayedResponseHeader(uint32_t aSendTime, const Ip6::Address &amp;aDestination)</div><div class="ttdoc">This constructor initializes the object with specific values. </div><div class="ttdef"><b>Definition:</b> mle_router.hpp:87</div></div>
<div class="ttc" id="classThread_1_1Timer_html"><div class="ttname"><a href="../../d1/d40/classThread_1_1Timer.html">Thread::Timer</a></div><div class="ttdoc">This class implements a timer. </div><div class="ttdef"><b>Definition:</b> timer.hpp:138</div></div>
<div class="ttc" id="group__core-mle-router_html_gaa2e15142a8cca7f278fd4d887aca6e3f"><div class="ttname"><a href="../../db/dec/group__core-mle-router.html#gaa2e15142a8cca7f278fd4d887aca6e3f">Thread::Mle::DelayedResponseHeader::IsEarlier</a></div><div class="ttdeci">bool IsEarlier(uint32_t aTime)</div><div class="ttdoc">This method checks if the message shall be sent before the given time. </div><div class="ttdef"><b>Definition:</b> mle_router.hpp:153</div></div>
<div class="ttc" id="classThread_1_1Mle_1_1LeaderDataTlv_html"><div class="ttname"><a href="../../d5/d64/classThread_1_1Mle_1_1LeaderDataTlv.html">Thread::Mle::LeaderDataTlv</a></div><div class="ttdoc">This class implements Source Address TLV generation and parsing. </div><div class="ttdef"><b>Definition:</b> mle_tlvs.hpp:705</div></div>
<div class="ttc" id="classThread_1_1MessageQueue_html"><div class="ttname"><a href="../../da/d1a/classThread_1_1MessageQueue.html">Thread::MessageQueue</a></div><div class="ttdoc">This class implements a message queue. </div><div class="ttdef"><b>Definition:</b> message.hpp:626</div></div>
<div class="ttc" id="classThread_1_1Mle_1_1AddressRegistrationTlv_html"><div class="ttname"><a href="../../df/dd8/classThread_1_1Mle_1_1AddressRegistrationTlv.html">Thread::Mle::AddressRegistrationTlv</a></div><div class="ttdoc">This class implements Source Address TLV generation and parsing. </div><div class="ttdef"><b>Definition:</b> mle_tlvs.hpp:1406</div></div>
<div class="ttc" id="trickle__timer_8hpp_html"><div class="ttname"><a href="../../d0/d11/trickle__timer_8hpp.html">trickle_timer.hpp</a></div><div class="ttdoc">This file includes definitions for the trickle timer logic. </div></div>
<div class="ttc" id="udp6_8hpp_html"><div class="ttname"><a href="../../d0/db7/udp6_8hpp.html">udp6.hpp</a></div><div class="ttdoc">This file includes definitions for UDP/IPv6 sockets. </div></div>
<div class="ttc" id="group__core-mle-router_html_gac459664defd97a4462d24b88153e188b"><div class="ttname"><a href="../../db/dec/group__core-mle-router.html#gac459664defd97a4462d24b88153e188b">Thread::Mle::DelayedResponseHeader::ReadFrom</a></div><div class="ttdeci">uint16_t ReadFrom(Message &amp;aMessage)</div><div class="ttdoc">This method reads delayed response header from the message. </div><div class="ttdef"><b>Definition:</b> mle_router.hpp:113</div></div>
<div class="ttc" id="mac__frame_8hpp_html"><div class="ttname"><a href="../../d1/d97/mac__frame_8hpp.html">mac_frame.hpp</a></div><div class="ttdoc">This file includes definitions for generating and processing IEEE 802.15.4 MAC frames. </div></div>
<div class="ttc" id="structotNeighborInfo_html"><div class="ttname"><a href="../../d9/df7/structotNeighborInfo.html">otNeighborInfo</a></div><div class="ttdoc">This structure holds diagnostic information for a neighboring Thread node. </div><div class="ttdef"><b>Definition:</b> openthread-types.h:709</div></div>
<div class="ttc" id="structotChildInfo_html"><div class="ttname"><a href="../../d3/d06/structotChildInfo.html">otChildInfo</a></div><div class="ttdoc">This structure holds diagnostic information for a Thread Child. </div><div class="ttdef"><b>Definition:</b> openthread-types.h:733</div></div>
<div class="ttc" id="classThread_1_1Message_html_a76033bbc15170d72452186058defafa2"><div class="ttname"><a href="../../dc/d3c/classThread_1_1Message.html#a76033bbc15170d72452186058defafa2">Thread::Message::Read</a></div><div class="ttdeci">uint16_t Read(uint16_t aOffset, uint16_t aLength, void *aBuf) const </div><div class="ttdoc">This method reads bytes from the message. </div><div class="ttdef"><b>Definition:</b> message.cpp:284</div></div>
<div class="ttc" id="mle__tlvs_8hpp_html"><div class="ttname"><a href="../../d1/df7/mle__tlvs_8hpp.html">mle_tlvs.hpp</a></div><div class="ttdoc">This file includes definitions for generating and processing MLE TLVs. </div></div>
<div class="ttc" id="classThread_1_1Coap_1_1Header_html"><div class="ttname"><a href="../../d0/d7f/classThread_1_1Coap_1_1Header.html">Thread::Coap::Header</a></div><div class="ttdoc">This class implements CoAP header generation and parsing. </div><div class="ttdef"><b>Definition:</b> coap_header.hpp:68</div></div>
<div class="ttc" id="group__core-mle-router_html_gadb5de3038cf6d4ca911f3ba9160c3bdf"><div class="ttname"><a href="../../db/dec/group__core-mle-router.html#gadb5de3038cf6d4ca911f3ba9160c3bdf">Thread::Mle::DelayedResponseHeader::IsLater</a></div><div class="ttdeci">bool IsLater(uint32_t aTime)</div><div class="ttdoc">This method checks if the message shall be sent after the given time. </div><div class="ttdef"><b>Definition:</b> mle_router.hpp:163</div></div>
<div class="ttc" id="coap__server_8hpp_html"><div class="ttname"><a href="../../dd/d28/coap__server_8hpp.html">coap_server.hpp</a></div><div class="ttdoc">This file includes definitions for the CoAP server. </div></div>
<div class="ttc" id="group__core-mle-router_html_gaadf8242dcc10ab86e29321ac2ffa771c"><div class="ttname"><a href="../../db/dec/group__core-mle-router.html#gaadf8242dcc10ab86e29321ac2ffa771c">Thread::Mle::DelayedResponseHeader::RemoveFrom</a></div><div class="ttdeci">static ThreadError RemoveFrom(Message &amp;aMessage)</div><div class="ttdoc">This method removes delayed response header from the message. </div><div class="ttdef"><b>Definition:</b> mle_router.hpp:125</div></div>
<div class="ttc" id="classThread_1_1ThreadStatusTlv_html_a0a1376dc8bb01111ac1a21170188fdf8"><div class="ttname"><a href="../../d4/df4/classThread_1_1ThreadStatusTlv.html#a0a1376dc8bb01111ac1a21170188fdf8">Thread::ThreadStatusTlv::Status</a></div><div class="ttdeci">Status</div><div class="ttdoc">Status values. </div><div class="ttdef"><b>Definition:</b> thread_tlvs.hpp:326</div></div>
<div class="ttc" id="group__core-mle-router_html_ga68eea6791f7f1ab21eda738487066b14"><div class="ttname"><a href="../../db/dec/group__core-mle-router.html#ga68eea6791f7f1ab21eda738487066b14">Thread::Mle::MleRouter::IsRouterIdValid</a></div><div class="ttdeci">static bool IsRouterIdValid(uint8_t aRouterId)</div><div class="ttdoc">This method checks if a given Router ID has correct value. </div><div class="ttdef"><b>Definition:</b> mle_router.hpp:618</div></div>
<div class="ttc" id="classThread_1_1Coap_1_1Resource_html"><div class="ttname"><a href="../../d0/d63/classThread_1_1Coap_1_1Resource.html">Thread::Coap::Resource</a></div><div class="ttdoc">This class implements CoAP resource handling. </div><div class="ttdef"><b>Definition:</b> coap_server.hpp:55</div></div>
<div class="ttc" id="classThread_1_1Mle_1_1Mle_html"><div class="ttname"><a href="../../dd/ddf/classThread_1_1Mle_1_1Mle.html">Thread::Mle::Mle</a></div><div class="ttdoc">This class implements MLE functionality required by the Thread EndDevices, Router, and Leader roles. </div><div class="ttdef"><b>Definition:</b> mle.hpp:346</div></div>
<div class="ttc" id="group__core-mle-router_html_ga6e4dd015cd242d97b89d2523f5132cf8"><div class="ttname"><a href="../../db/dec/group__core-mle-router.html#ga6e4dd015cd242d97b89d2523f5132cf8">Thread::Mle::DelayedResponseHeader::AppendTo</a></div><div class="ttdeci">ThreadError AppendTo(Message &amp;aMessage)</div><div class="ttdoc">This method appends delayed response header to the message. </div><div class="ttdef"><b>Definition:</b> mle_router.hpp:101</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1UdpSocket_html"><div class="ttname"><a href="../../dc/d75/classThread_1_1Ip6_1_1UdpSocket.html">Thread::Ip6::UdpSocket</a></div><div class="ttdoc">This class implements a UDP/IPv6 socket. </div><div class="ttdef"><b>Definition:</b> udp6.hpp:59</div></div>
<div class="ttc" id="timer_8hpp_html"><div class="ttname"><a href="../../df/d05/timer_8hpp.html">timer.hpp</a></div><div class="ttdoc">This file includes definitions for the multiplexed timer service. </div></div>
<div class="ttc" id="classThread_1_1Coap_1_1Server_html"><div class="ttname"><a href="../../de/d76/classThread_1_1Coap_1_1Server.html">Thread::Coap::Server</a></div><div class="ttdoc">This class implements the CoAP server. </div><div class="ttdef"><b>Definition:</b> coap_server.hpp:101</div></div>
<div class="ttc" id="group__toolchain_html_gacf07d7a4a2ea6d0cc3426234565fcb7b"><div class="ttname"><a href="../../d7/da1/group__toolchain.html#gacf07d7a4a2ea6d0cc3426234565fcb7b">OT_TOOL_PACKED_END</a></div><div class="ttdeci">#define OT_TOOL_PACKED_END</div><div class="ttdoc">Compiler-specific indication at the end of a byte packed class or struct. </div><div class="ttdef"><b>Definition:</b> toolchain.h:131</div></div>
<div class="ttc" id="structThread_1_1Mac_1_1Address_html"><div class="ttname"><a href="../../dd/dcd/structThread_1_1Mac_1_1Address.html">Thread::Mac::Address</a></div><div class="ttdoc">This structure represents an IEEE 802.15.4 Short or Extended Address. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:152</div></div>
<div class="ttc" id="structotMessageInfo_html"><div class="ttname"><a href="../../dd/d76/structotMessageInfo.html">otMessageInfo</a></div><div class="ttdoc">This structure represents the local and peer IPv6 socket addresses. </div><div class="ttdef"><b>Definition:</b> openthread-types.h:902</div></div>
<div class="ttc" id="classThread_1_1Message_html_a3c3d1c48e940f2553586d16e1618277d"><div class="ttname"><a href="../../dc/d3c/classThread_1_1Message.html#a3c3d1c48e940f2553586d16e1618277d">Thread::Message::Append</a></div><div class="ttdeci">ThreadError Append(const void *aBuf, uint16_t aLength)</div><div class="ttdoc">This method appends bytes to the end of the message. </div><div class="ttdef"><b>Definition:</b> message.cpp:252</div></div>
<div class="ttc" id="group__messages_html_ga461fb1347aeb99b1d4aab520915e121e"><div class="ttname"><a href="../../d4/d7c/group__messages.html#ga461fb1347aeb99b1d4aab520915e121e">otMessage</a></div><div class="ttdeci">void * otMessage</div><div class="ttdoc">This type points to an OpenThread message buffer. </div><div class="ttdef"><b>Definition:</b> openthread-types.h:872</div></div>
<div class="ttc" id="group__config-test_html_gae4ed9d6e7bf2a1d196d9e36f3769e7b8"><div class="ttname"><a href="../../db/d57/group__config-test.html#gae4ed9d6e7bf2a1d196d9e36f3769e7b8">otMleAttachFilter</a></div><div class="ttdeci">otMleAttachFilter</div><div class="ttdoc">Represents any restrictions on the attach process. </div><div class="ttdef"><b>Definition:</b> openthread-types.h:644</div></div>
<div class="ttc" id="classThread_1_1Mle_1_1DelayedResponseHeader_html"><div class="ttname"><a href="../../d2/df0/classThread_1_1Mle_1_1DelayedResponseHeader.html">Thread::Mle::DelayedResponseHeader</a></div><div class="ttdoc">This class implements functionality required for delaying MLE responses. </div><div class="ttdef"><b>Definition:</b> mle_router.hpp:71</div></div>
<div class="ttc" id="classThread_1_1Message_html_a2cf440376e834030c38bb2ced4ca49e9"><div class="ttname"><a href="../../dc/d3c/classThread_1_1Message.html#a2cf440376e834030c38bb2ced4ca49e9">Thread::Message::GetLength</a></div><div class="ttdeci">uint16_t GetLength(void) const </div><div class="ttdoc">This method returns the number of bytes in the message. </div><div class="ttdef"><b>Definition:</b> message.cpp:169</div></div>
<div class="ttc" id="classThread_1_1Mle_1_1MleRouter_html"><div class="ttname"><a href="../../df/da5/classThread_1_1Mle_1_1MleRouter.html">Thread::Mle::MleRouter</a></div><div class="ttdoc">This class implements MLE functionality required by the Thread Router and Leader roles. </div><div class="ttdef"><b>Definition:</b> mle_router.hpp:174</div></div>
<div class="ttc" id="classThread_1_1Mle_1_1ConnectivityTlv_html"><div class="ttname"><a href="../../d2/df0/classThread_1_1Mle_1_1ConnectivityTlv.html">Thread::Mle::ConnectivityTlv</a></div><div class="ttdoc">This class implements Source Address TLV generation and parsing. </div><div class="ttdef"><b>Definition:</b> mle_tlvs.hpp:987</div></div>
<div class="ttc" id="icmp6_8hpp_html"><div class="ttname"><a href="../../d0/dba/icmp6_8hpp.html">icmp6.hpp</a></div><div class="ttdoc">This file includes definitions for ICMPv6. </div></div>
<div class="ttc" id="group__toolchain_html_gaba6ad63129c3a790957a9b149a65891b"><div class="ttname"><a href="../../d7/da1/group__toolchain.html#gaba6ad63129c3a790957a9b149a65891b">OT_TOOL_PACKED_BEGIN</a></div><div class="ttdeci">#define OT_TOOL_PACKED_BEGIN</div><div class="ttdoc">Compiler-specific indication that a class or struct must be byte packed. </div><div class="ttdef"><b>Definition:</b> toolchain.h:129</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1ExtAddress_html"><div class="ttname"><a href="../../d9/d3c/classThread_1_1Mac_1_1ExtAddress.html">Thread::Mac::ExtAddress</a></div><div class="ttdoc">This structure represents an IEEE 802.15.4 Extended Address. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:81</div></div>
<div class="ttc" id="namespaceThread_html"><div class="ttname"><a href="../../d9/d00/namespaceThread.html">Thread</a></div><div class="ttdef"><b>Definition:</b> cli.cpp:61</div></div>
<div class="ttc" id="classThread_1_1Router_html"><div class="ttname"><a href="../../db/d81/classThread_1_1Router.html">Thread::Router</a></div><div class="ttdoc">This class represents a Thread Router. </div><div class="ttdef"><b>Definition:</b> topology.hpp:119</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1Address_html"><div class="ttname"><a href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Thread::Ip6::Address</a></div><div class="ttdoc">This class implements an IPv6 address object. </div><div class="ttdef"><b>Definition:</b> ip6_address.hpp:56</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="../../dir_aebb8dcc11953d78e620bbef0b9e2183.html">core</a></li><li class="navelem"><a class="el" href="../../dir_fd71accbf528c1576ca21e7ec5716833.html">thread</a></li><li class="navelem"><a class="el" href="../../d6/d6f/mle__router_8hpp.html">mle_router.hpp</a></li>
    <li class="footer">Generated on Fri Oct 14 2016 08:44:34 for OpenThread by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="../../doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
